Index: tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RStatsEngine.java
===================================================================
--- tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RStatsEngine.java	(revision 782)
+++ tmp/org.txm.statsengine.r.core/src/org/txm/statsengine/r/core/RStatsEngine.java	(revision 783)
@@ -4,7 +4,7 @@
 
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.txm.core.preferences.TXMPreferences;
-import org.txm.statsengine.core.StatEngine;
+import org.txm.statsengine.core.StatsEngine;
 import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
 import org.txm.statsengine.r.core.messages.RCoreMessages;
 import org.txm.statsengine.r.core.preferences.RPreferences;
@@ -18,7 +18,7 @@
  * @author sjacquot
  *
  */
-public class RStatsEngine extends StatEngine {
+public class RStatsEngine extends StatsEngine {
 
 	
 	/** The state of the stats engine. */
Index: tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/preferences/LexicalTablePreferences.java
===================================================================
--- tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/preferences/LexicalTablePreferences.java	(revision 782)
+++ tmp/org.txm.lexicaltable.core/src/org/txm/lexicaltable/core/preferences/LexicalTablePreferences.java	(revision 783)
@@ -46,7 +46,6 @@
 		Preferences preferences = DefaultScope.INSTANCE.getNode(PREFERENCES_NODE);
 		preferences.putInt(F_MIN, 2);
 		preferences.putInt(V_MAX, 200);
-		preferences.put(UNIT_PROPERTY, DEFAULT_UNIT_PROPERTY);
 		preferences.putBoolean(USE_ALL_OCCURRENCES, true);
 	}
 	
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/testers/ToolboxTester.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/testers/ToolboxTester.java	(revision 782)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/testers/ToolboxTester.java	(revision 783)
@@ -28,7 +28,7 @@
 			Object expectedValue) {
 		if (PROPERTY_STATE_ENGINE_READY.equals(property)) {
 			//System.out.println("TEST: "+property+" = "+Toolbox.getEngineManager(EngineType.STAT).getEngine("R").getState()); //$NON-NLS-1$ //$NON-NLS-2$
-			return Toolbox.getEngineManager(EngineType.STAT).getEngine("R").getState();
+			return Toolbox.getEngineManager(EngineType.STATS).getEngine("R").getState();
 		} else if (PROPERTY_SEARCH_ENGINE_READY.equals(property)) {
 			System.out.println("TEST: "+property+" = "+CQPEngine.isInitialized()); //$NON-NLS-1$ //$NON-NLS-2$
 			return CQPEngine.isInitialized();
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/corpora/CorporaView.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/corpora/CorporaView.java	(revision 782)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/corpora/CorporaView.java	(revision 783)
@@ -56,6 +56,7 @@
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.swt.widgets.Menu;
+import org.eclipse.swt.widgets.TreeColumn;
 import org.eclipse.swt.widgets.TreeItem;
 import org.eclipse.ui.IEditorPart;
 import org.eclipse.ui.IWorkbenchPage;
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/debug/TXMResultDebugView.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/debug/TXMResultDebugView.java	(revision 782)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/views/debug/TXMResultDebugView.java	(revision 783)
@@ -110,6 +110,9 @@
 		buffer.append("toString(): " + this.currentResult.toString() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
 		buffer.append("Details: " + this.currentResult.getDetails() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
 		buffer.append("Dirty: " + this.currentResult.isDirty() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+		if (this.currentResult instanceof ChartResult) 	{
+			buffer.append("Chart dirty: " + ((ChartResult)this.currentResult).isChartDirty() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
+		}
 		
 		// Object parameters
 		buffer.append("\n"); //$NON-NLS-1$
@@ -125,7 +128,9 @@
 		buffer.append("Selected object = " + this.currentResult + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
 		buffer.append("Node visible = " + this.currentResult.isVisible() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$
 		if (this.currentResult instanceof ChartResult) 	{
-			buffer.append("Chart engine = " + ((ChartResult)this.currentResult).getChartsEngine() + ", chart object = " + ((ChartResult)this.currentResult).getChart() + ", chart type = " + ((ChartResult)this.currentResult).getChartType() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+			buffer.append("Chart engine = " + ((ChartResult)this.currentResult).getChartsEngine() + ", chart object = " + ((ChartResult)this.currentResult).getChart()
+					+ ", chart type = " + ((ChartResult)this.currentResult).getChartType()
+					+ "\n");
 		}
 		buffer.append("Selection full path name = " + this.currentResult.getFullPathSimpleName() + " - " + this.currentResult.getName() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
 		buffer.append("Direct children count = " + this.currentResult.getChildren().size() + ", direct visible children count = " + this.currentResult.getChildren(true).size() + ", children count = " + this.currentResult.getDeepChildren().size() + "\n"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 782)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 783)
@@ -77,7 +77,7 @@
 	 */
 	public final static String TOP_TOOLBAR_ID = "TXMEditorTopToolBar"; //$NON-NLS-1$
 	public final static String BOTTOM_TOOLBAR_ID = "TXMEditorBottomToolBar"; //$NON-NLS-1$
-	public final static String COMPUTING_PARAMETERS_GROUP_ID = "Parameters";
+	public final static String COMPUTING_PARAMETERS_GROUP_ID = "Parameters"; //$NON-NLS-1$
 
 	/**
 	 * The editor main tool bar, positioned at the top of the editor.
@@ -97,14 +97,21 @@
 	/**
 	 * the parameters groups are added to this composite. contains the sub widgets of the default Top toolbar
 	 */
-	private GLComposite parametersGroupsComposite;
+	private GLComposite extendedParametersGroupsComposite;
 
+
 	/**
-	 * The command parameters composite that can be hidden. To add main parameters.
+	 * Command main parameters that are always visible in the toolbar. 
 	 */
-	protected Composite computingParametersGroup;
+	protected GLComposite mainParametersComposite;
 
+	
 	/**
+	 * Command extended parameters composite that can be hidden.
+	 */
+	protected Composite extendedParametersComposite;
+
+	/**
 	 * 
 	 */
 	Composite parent;
@@ -126,7 +133,6 @@
 	 * contains bottom toolbar subwidgets (installed grouped, etc.)
 	 */
 	private GLComposite bottomSubWidgetsComposite;
-	private GLComposite minimalParametersComposite;
 	private GLComposite firstLineComposite;
 	private boolean createPartControlDoneSucessfully = true; // for now... muahahaha
 
@@ -147,8 +153,8 @@
 	 *  
 	 * @return the composite displayed before the toptoolbar, containing the minimal parameters widgets
 	 */
-	public GLComposite getMinimalParametersComposite() {
-		return minimalParametersComposite;
+	public GLComposite getMainParametersComposite() {
+		return mainParametersComposite;
 	}
 
 	/**
@@ -161,7 +167,7 @@
 		try {
 			this.parent = parent;
 
-			// to hide and display the command parameters composite
+			// to hide and display the extended parameters composite
 			this.initParentLayout(parent, 1);
 
 			// contains the minimal panels and top toolbars
@@ -169,11 +175,10 @@
 			this.firstLineComposite.getLayout().numColumns = 2;
 			this.firstLineComposite.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
 
-			this.minimalParametersComposite = new GLComposite(firstLineComposite, SWT.NONE);
-			this.minimalParametersComposite.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
-			this.minimalParametersComposite.getLayout().horizontalSpacing = 5;
+			this.mainParametersComposite = new GLComposite(firstLineComposite, SWT.NONE);
+			this.mainParametersComposite.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
+			this.mainParametersComposite.getLayout().horizontalSpacing = 5;
 
-
 			// create the top tool bar
 			this.topToolBarContainer = new Composite(firstLineComposite, SWT.NONE);
 			this.topToolBarContainer.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false));
@@ -183,27 +188,33 @@
 			rl.center = true;
 			this.topToolBarContainer.setLayout(rl);
 
-			this.parametersGroupsComposite = new GLComposite(parent, SWT.NONE);
+			this.extendedParametersGroupsComposite = new GLComposite(parent, SWT.NONE);
 			if (parent.getLayout() instanceof GridLayout)	{
-				this.parametersGroupsComposite.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
+				this.extendedParametersGroupsComposite.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
 			}
 
-			this.topToolBar = new TXMEditorToolBar(this, this.topToolBarContainer, this.parametersGroupsComposite, SWT.FLAT | SWT.RIGHT, TOP_TOOLBAR_ID);
+			this.topToolBar = new TXMEditorToolBar(this, this.topToolBarContainer, this.extendedParametersGroupsComposite, SWT.FLAT | SWT.RIGHT, TOP_TOOLBAR_ID);
 			// FIXME: debug tests for see why there is an empty area at bottom of the toolbar
 			//this.topToolBar.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
 
+			
+			
 			// computing parameters components
-			boolean showComputingParameters = false;
+			boolean showExtendedParameters = false;
 			// only show the area if the result can not compute and is dirty
-			if(!this.getResult().canCompute() && this.getResult().isDirty())	{
-				showComputingParameters = true;
-			}
-			this.computingParametersGroup = this.topToolBar.installGroup(COMPUTING_PARAMETERS_GROUP_ID, "Show/Hide command parameters", 
+			// FIXME: to discuss if when hiding or showing the extended parameters 
+//			if(!this.getResult().canCompute() && this.getResult().isDirty())	{
+//				showExtendedParameters = true;
+//			}
+			this.extendedParametersComposite = this.topToolBar.installGroup(COMPUTING_PARAMETERS_GROUP_ID, "Show/Hide command parameters", 
 					"icons/show_computing_parameters.png", 
 					"icons/hide_computing_parameters.png", 
-					showComputingParameters);
+					showExtendedParameters);
 
+			//extendedParametersComposite.setBackground(parent.getDisplay().getSystemColor(SWT.COLOR_RED));
 
+			
+			
 			// display main area
 			this.resultArea = new Composite(parent, SWT.NONE);
 			this.resultArea.setLayoutData(new GridData(GridData.FILL_BOTH));
@@ -217,13 +228,19 @@
 			//rl.justify = true;
 			this.bottomToolBarContainer.setLayout(rl);
 
+			
 			this.bottomSubWidgetsComposite = new GLComposite(parent, SWT.NONE);
 			if (parent.getLayout() instanceof GridLayout)	{
 				this.bottomSubWidgetsComposite.setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
 			}
 
+			
 			this.bottomToolBar = new TXMEditorToolBar(this, this.bottomToolBarContainer, this.bottomSubWidgetsComposite, SWT.FLAT, "bottom");
 
+			
+
+
+			
 			this._createPartControl(parent); // child editor create its parameters and display widgets
 
 
@@ -240,14 +257,14 @@
 			}
 
 			// uninstall parameters group if not used
-			if (computingParametersGroup.getChildren().length == 0) {
+			if (extendedParametersComposite.getChildren().length == 0) {
 				this.topToolBar.unInstallGroup(COMPUTING_PARAMETERS_GROUP_ID);
 			}
 		}
 		catch(Throwable e) {
-			System.err.println("TXMEditor.createPartControl(): can not create the editor.");
+			System.err.println("TXMEditor.createPartControl(): can not create the editor for result " + this.getResult() + ".");
 			e.printStackTrace();
-			createPartControlDoneSucessfully  = false;
+			createPartControlDoneSucessfully = false;
 		}
 	}
 
@@ -319,8 +336,8 @@
 	/**
 	 * @return the commandParametersComposite. Put here you main parameter widgets
 	 */
-	public Composite getCommandParametersGroup() {
-		return this.computingParametersGroup;
+	public Composite getExtendedParametersComposite() {
+		return this.extendedParametersComposite;
 	}
 
 	@Override
@@ -340,7 +357,7 @@
 	public boolean isDirty() {
 		if (this.getResult() != null) {
 			// if the result has never been computed, the editor is not dirty ->  no * shown
-			return this.getResult().isDirty() && this.getResult().getHasBeenComputedOnce();
+			return this.getResult().isDirty() && this.getResult().hasBeenComputedOnce();
 		}
 
 		return false;
@@ -440,7 +457,6 @@
 	 */
 	public JobHandler compute(final boolean update)	{
 
-
 		StatusLine.setMessage("Computing " + this.getResult().getName());
 
 		JobHandler job = new JobHandler("Computing " + this.getResult().getName()) {
@@ -958,7 +974,7 @@
 	 * @return the composite that contains the <b>default Top</b> TXMEditorToolBar parameters panels
 	 */
 	public GLComposite getParametersGroupsComposite() {
-		return parametersGroupsComposite;
+		return extendedParametersGroupsComposite;
 	}
 
 	/**
Index: tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/editors/CooccurrencesEditor.java
===================================================================
--- tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/editors/CooccurrencesEditor.java	(revision 782)
+++ tmp/org.txm.cooccurrence.rcp/src/org/txm/cooccurrence/rcp/editors/CooccurrencesEditor.java	(revision 783)
@@ -209,7 +209,7 @@
 		// paramLayoutData.right = new FormAttachment(100);
 		// scrollComposite.setLayoutData(paramLayoutData);
 
-		final Composite paramArea = this.getCommandParametersGroup();
+		final Composite paramArea = this.getExtendedParametersComposite();
 		FormLayout paramLayout = new FormLayout();
 		paramArea.setLayout(paramLayout);
 
@@ -245,15 +245,15 @@
 
 		queryArea.setLayout(new GridLayout(3, false));
 
-		getMinimalParametersComposite().getLayout().numColumns = 3;
-		getMinimalParametersComposite().setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
+		getMainParametersComposite().getLayout().numColumns = 3;
+		getMainParametersComposite().setLayoutData(new GridData(GridData.FILL, GridData.FILL, true, false));
 		
-		Label queryLabel = new Label(getMinimalParametersComposite(), SWT.NONE);
+		Label queryLabel = new Label(getMainParametersComposite(), SWT.NONE);
 		queryLabel.setText(TXMCoreMessages.common_query);
 		queryLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, true));
 
 		// [ (v)]
-		queryWidget = new AssistedQueryWidget(getMinimalParametersComposite(), SWT.DROP_DOWN, this.cooc.getCorpus());
+		queryWidget = new AssistedQueryWidget(getMainParametersComposite(), SWT.DROP_DOWN, this.cooc.getCorpus());
 		GridData layoutData = new GridData(GridData.VERTICAL_ALIGN_CENTER);
 		layoutData.horizontalAlignment = GridData.FILL;
 		layoutData.grabExcessHorizontalSpace = true;
Index: tmp/org.txm.specificities.core/src/org/txm/specificities/core/functions/Specificities.java
===================================================================
--- tmp/org.txm.specificities.core/src/org/txm/specificities/core/functions/Specificities.java	(revision 782)
+++ tmp/org.txm.specificities.core/src/org/txm/specificities/core/functions/Specificities.java	(revision 783)
@@ -45,6 +45,7 @@
 import org.txm.lexicaltable.core.functions.LexicalTable;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
+import org.txm.searchengine.cqp.corpus.Partition;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.specificities.core.messages.SpecificitiesCoreMessages;
 import org.txm.specificities.core.preferences.SpecificitiesPreferences;
@@ -185,23 +186,27 @@
 	@Override
 	protected boolean _compute() throws Exception {
 		
-
 		// recompute the lexical table
 		if(this.hasParameterChanged(SpecificitiesPreferences.UNIT_PROPERTY))	{
 			this.lexicalTable.setUnitProperty(this.unitProperty);
-			this.lexicalTable.compute();
+			this.lexicalTable.compute(this, false);
 		}
 
-		SpecificitiesR rSpecificities = new SpecificitiesR(this.lexicalTable.getData());
-		double[][] specIndex = rSpecificities.getScores();
-
+		// essentially for cascade computing from the parent lexical table
+		this.unitProperty = this.lexicalTable.getProperty();
 		
-		if (lexicalTable.getPartition() != null) {
-			init(symbol, specIndex, this.unitProperty.getName()); 
+		if(this.lexicalTable.hasBeenComputedOnce())	{
+			SpecificitiesR rSpecificities = new SpecificitiesR(this.lexicalTable.getData());
+			double[][] specIndex = rSpecificities.getScores();
+	
+			
+			if (this.lexicalTable.getPartition() != null) {
+				init(symbol, specIndex, this.unitProperty.getName()); 
+			}
+			else {
+				init(rSpecificities.getSymbol(), specIndex, "TLNONAME: " + this.unitProperty.getName()); //$NON-NLS-1$
+			}
 		}
-		else {
-			init(rSpecificities.getSymbol(), specIndex, "TLNONAME: " + this.unitProperty.getName()); //$NON-NLS-1$
-		}
 		return true;
 	}
 	
@@ -378,7 +383,12 @@
 			 * partShortNames.length; i++) { partShortNames[i] =
 			 * parts.get(i).getShortName(); }
 			 */
-			return lexicalTable.getColNames().asStringsArray();
+			try {
+				return lexicalTable.getColNames().asStringsArray();
+			}
+			catch (Exception e) {
+				return ((Partition)this.lexicalTable.getParent()).getPartShortNames().toArray(new String[0]);
+			}
 		} else if (this.subCorpus != null) {
 			return new String[] { this.subCorpus.getName(), this.corpus.getName() + " \\ " + this.subCorpus.getName() }; //$NON-NLS-1$
 		}
@@ -448,14 +458,23 @@
 	 *
 	 * @return the part size
 	 * @throws StatException the stat exception
+	 * @throws CqiClientException 
 	 */
-	public int[] getPartSizes() throws StatException {
+	public int[] getPartSizes() throws StatException, CqiClientException {
 		if (lexicalTable != null) {
-			Vector partsize = lexicalTable.getColMarginsVector();
-			if (colindex != null) {
-				partsize = partsize.get(colindex);
+			
+			try {
+				Vector partsize = lexicalTable.getColMarginsVector();
+				if (colindex != null) {
+					partsize = partsize.get(colindex);
+				}
+				return partsize.asIntArray();
 			}
-			return partsize.asIntArray();
+			catch (Exception e) {
+				return ((Partition)this.lexicalTable.getParent()).getPartSizes();
+			}
+			
+			
 		} else {
 			return new int[] { subLexicon.nbrOfToken(),
 					lexicon.nbrOfToken() - subLexicon.nbrOfToken() };
@@ -608,7 +627,15 @@
 //		} else {
 //			setPartName(specificitiesResult.getName());
 //		}
-		return name;
+		// FIXME: to define
+		if(name != null)	{
+			return name;	
+		}
+		else	{
+			return this.getEmptyName();
+		}
+
+		
 	}
 
 
@@ -629,9 +656,13 @@
 	public boolean canCompute() {
 		
 		if (this.lexicalTable == null) {
-			Log.severe("Specificities.canCompute(): Can not compute without a lexical table.");
+			Log.severe("Specificities.canCompute(): can not compute without a lexical table.");
 			return false;
 		}
+		else if(this.unitProperty == null)	{
+			Log.severe("Specificities.canCompute(): can not compute with no unit property."); //$NON-NLS-1$
+			return false;
+		}
 		
 //		if (this.lexicalTable.getNColumns() < 2) {
 //			Log.severe(SpecificitiesCoreMessages.ComputeError_NEED_AT_LEAST_2_PARTS);
Index: tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEnginesManager.java
===================================================================
--- tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEnginesManager.java	(revision 0)
+++ tmp/org.txm.searchengine.core/src/org/txm/searchengine/core/SearchEnginesManager.java	(revision 783)
@@ -0,0 +1,100 @@
+package org.txm.searchengine.core;
+
+import org.eclipse.core.runtime.IConfigurationElement;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.Platform;
+import org.txm.Engine;
+import org.txm.EngineType;
+import org.txm.EnginesManager;
+import org.txm.Toolbox;
+
+/**
+ * 
+ * @author mdecorde
+ *
+ */
+public class SearchEnginesManager extends EnginesManager<SearchEngine> {
+
+	/**
+	 * 
+	 * @return
+	 */
+	public static SearchEngine getCQPEngine() {
+		return (SearchEngine) Toolbox.getEngineManager(EngineType.SEARCH).getEngine("CQP");
+	}
+
+	/**
+	 * 
+	 * @return
+	 */
+	public static SearchEngine getTIGERSearchEngine() {
+		return (SearchEngine) Toolbox.getEngineManager(EngineType.SEARCH).getEngine("TIGERSearch");
+	}
+
+	@Override
+	protected boolean fetchEngines() {
+
+		IConfigurationElement[] contributions = Platform.getExtensionRegistry().getConfigurationElementsFor(SearchEngine.EXTENSION_POINT_ID);
+		//System.out.println("search engine contributions: "+SearchEngine.EXTENSION_POINT_ID);
+		for (int i = 0; i < contributions.length; i++) {
+			try {
+				SearchEngine e = (SearchEngine)contributions[i].createExecutableExtension("class"); //$NON-NLS-1$
+				
+				System.out.println("Initializing engine: " + e);
+				
+				if (e.initialize()) {
+					engines.put(e.getName(), e);
+				}
+				else {
+					System.err.println("Failed to initialize " + e.getName() + " search engine.");
+				}
+			} catch(Exception e) {
+				System.err.println("Error: failed to instantiate " + contributions[i].getName() + ": " + e.getLocalizedMessage());
+				e.printStackTrace();
+			}
+		}
+
+		return engines.size() > 0;
+	}
+
+	@Override
+	public EngineType getEnginesType() {
+		return EngineType.SEARCH;
+	}
+
+	@Override
+	public boolean startEngines(IProgressMonitor monitor) {
+
+		for (Engine e : engines.values()) {
+			SearchEngine se = (SearchEngine)e;
+			//System.out.println("Starting "+ se.getName()+" searchengine.");
+			if (monitor != null) {
+				monitor.subTask("Starting " + se.getName() + " searchengine.");
+			}
+			try {
+				se.start(monitor);
+			} catch (Exception e2) {
+				System.err.println("Error: failed to start SearchEngine: " + se.getName() + ": " + e2.getLocalizedMessage());
+				e2.printStackTrace();
+			}
+		}
+		return true;
+	}
+
+	@Override
+	public boolean stopEngines() {
+		
+		for (Engine e : engines.values()) {
+			
+			SearchEngine se = (SearchEngine)e;
+			System.out.println("Stopping "+ se.getName()+" searchengine.");
+			try {
+				se.stop();
+			} catch (Exception e2) {
+				System.err.println("Error: failed to stop SearchEngine: " + se.getName() + ": " + e2.getLocalizedMessage());
+				e2.printStackTrace();
+			}
+		}
+		return true;
+	}
+}

Index: tmp/org.txm.tigersearch.rcp/src/org/txm/tigersearch/editors/TIGERSearchEditor.java
===================================================================
--- tmp/org.txm.tigersearch.rcp/src/org/txm/tigersearch/editors/TIGERSearchEditor.java	(revision 782)
+++ tmp/org.txm.tigersearch.rcp/src/org/txm/tigersearch/editors/TIGERSearchEditor.java	(revision 783)
@@ -68,7 +68,7 @@
 	public void _createPartControl(Composite parent) {
 
 		// System.out.println(parent.getLayout());
-		Composite queryPanel = this.getCommandParametersGroup();
+		Composite queryPanel = this.getExtendedParametersComposite();
 	
 		// fill query Area
 		GridLayout qlayout = new GridLayout(11, false);
Index: tmp/org.txm.core/src/java/org/txm/EnginesManager.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/EnginesManager.java	(revision 782)
+++ tmp/org.txm.core/src/java/org/txm/EnginesManager.java	(revision 783)
@@ -5,28 +5,47 @@
 import org.eclipse.core.runtime.IProgressMonitor;
 
 /**
- * Extension point for an Engine. It is a service that may be used by TXM commands
+ * Extension point for an Engine (eg. Search engine, Stats engine, etc.). It is a service that may be used by TXM commands.
+ * The Toolbox will manage the engines life-cycle. 
  * 
- * The Toolbox will manage the engines life-cycle 
- * 
  * @author mdecorde
  *
  */
 public abstract class EnginesManager<T extends Engine> {
 	
-	public static final String ENGINEMANAGER_EXTENSION_POINT_ID = EnginesManager.class.getName();
+	public static final String ENGINES_MANAGER_EXTENSION_POINT_ID = EnginesManager.class.getName();
 	
+	/**
+	 * Managed engines.
+	 */
 	protected HashMap<String, T> engines = new HashMap<String, T>();
 	
+	
 	/**
-	 * Findout the Engines that matches this EnginesManager Engine extension point
+	 * Current engine.
+	 */
+	protected T currentEngine = null; 
+	
+	
+	
+	/**
+	 * Returns the current engine.
+	 * @return
+	 */
+	public T getCurrentEngine() {
+		return this.currentEngine;
+	}
+	
+	
+	/**
+	 * Finds out the engines that matches this manager engines extension point.
 	 * 
 	 * @return
 	 */
 	protected abstract boolean fetchEngines();
 	
 	/**
-	 * Initialize the Engines once the TXM corpora is ready
+	 * Initializes the engines.
 	 * @param monitor 
 	 * 
 	 * @return
@@ -34,14 +53,14 @@
 	public abstract boolean startEngines(IProgressMonitor monitor);
 	
 	/**
-	 * Close the Engines, optional if the Engine is distant
+	 * Stops the engines.
 	 * 
 	 * @return
 	 */
 	public abstract boolean stopEngines();
 	
 	/**
-	 * Shortcut method to restart the Engines
+	 * Restarts the engines.
 	 * 
 	 * @return
 	 */
@@ -49,10 +68,11 @@
 		return stopEngines() && startEngines(null);
 	}
 	
+	
 	public abstract EngineType getEnginesType();
 	
 	/**
-	 * 
+	 * Gets the available engines. 
 	 * @return the available engines
 	 */
 	public HashMap<String, T> getEngines() {
@@ -60,9 +80,9 @@
 	}
 	
 	/**
-	 * 
+	 * Gets an engine specified by its name.
 	 * @param name
-	 * @return a specific engine by its name. May returns null.
+	 * @return an engine specified by its name if exists, otherwise null
 	 */
 	public T getEngine(String name) {
 		return engines.get(name);
